Codeforces Round 605 (Div. 3) A~D

2024-05-11 21:20
文章标签 codeforces round div 605

本文主要是介绍Codeforces Round 605 (Div. 3) A~D,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

本人水平不高,开这个专栏主要是督促自己补题,有些题对目前的我来说还比较难,还补不动,等以后能力上来了再补。。。

原题链接:Dashboard - Codeforces Round 605 (Div. 3) - Codeforces

目录

A. Three Friends

B. Snow Walking Robot

C. Yet Another Broken Keyboard

D. Remove One Element


A. Three Friends

让三个人尽可能接近,让左边的人和右边的人尽量往中间靠,a与b的距离| a-b |会减1,b与c的距离| b-c |也会 减1,而a与c的距离| a-c |会 减2。但是又因为是三个绝对值的式子相加,所以这三个式子之和必然大于等于0,取max(0ll,abs(a-b)+abs(b-c)+abs(a-c)-4) 即可。

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'void solve() {int a, b, c; cin >> a >> b >> c;cout << max(0ll, abs(a - b) + abs(b - c) + abs(a - c) - 4) << endl;
}signed main() {ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int T; cin >> T;while (T--) {solve();}return 0;
}

B. Snow Walking Robot

让机器人走一个(先向左再向上再向右再向下的)L—>U—>R—>D的矩形即可。

选择矩形的原因是“凹”形(下图左半部分)相比于与其效果相同的矩形,浪费了两个AB的长度。而“凸”形(下图右半部分)等价于虚线的矩形,而矩形比“凸”形简单,所以选择矩形。

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'void solve() {string s; cin >> s;int l=0, r=0, u=0, d = 0;for (auto i : s) {if (i == 'L') l++;else if (i == 'R') r++;else if (i == 'U') u++;else if (i == 'D') d++;}int x = min(l, r), y = min(u, d);if (x && y) {cout << 2 * x + 2 * y << endl;for (int i = 1; i <= x; i++) cout << 'L';for (int i = 1; i <= y; i++) cout << 'U';for (int i = 1; i <= x; i++) cout << 'R';for (int i = 1; i <= y; i++) cout << 'D';}else if (x) {cout << 2 << endl << "LR";}else if (y) {cout << 2 << endl << "UD";}else if (x == 0 && y == 0) {cout << 0 << endl;}cout << endl;
}signed main() {ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int T; cin >> T;while (T--) {solve();}return 0;
}

C. Yet Another Broken Keyboard

写法一:

开一个标记数组f[26]表示从'a'~'z’的字母是否是好的,如果是好的标记为1,否则为0。

遍历字符串s,开一个计数的变量cnt,初始化为0。当遇到好的字母(也就是f[s[i]-'a']为1),让cnt++。否则让ans+=cnt*(cnt+1)/2,并重新让cnt=0。因为末尾的那段不会在循环中被累加,所以在循环外我们还需要让ans再累加一次cnt*(cnt+1))/2 。

写法二:

可以用set代替标记数组。一开始将好的字母都存到set,后面使用set的s.find()函数(s.find() !=s.end() )来判断字符串中的字母是否是好的。

写法一代码:

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'
int f[26];signed main() {ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int n, k; cin >> n >> k;string s; cin >> s;while (k--) {char c; cin >> c;f[c - 'a' ] = 1;}int cnt = 0, ans = 0;;for (int i = 0; i < n; i++) {if (f[s[i]-'a']) {cnt++;}else {ans += cnt * (cnt + 1) / 2;cnt = 0;}}ans += cnt * (cnt + 1) / 2;cout << ans << endl;return 0;
}

写法二代码

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'
set<char> a;signed main() {ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int n, k; cin >> n >> k;string s; cin >> s;while (k--) {char c; cin >> c;a.insert(c);}int cnt = 0, ans = 0;;for (int i = 0; i < n; i++) {if (a.find(s[i]) != a.end()) {cnt++;}else {ans += cnt * (cnt + 1) / 2;cnt = 0;}}ans += cnt * (cnt + 1) / 2;cout << ans << endl;return 0;
}

D. Remove One Element

既然是求最长上升子序列,那必然是dp。由题意知,可以删除一个或者不删除。

1. 如果不删除,就是最长连续上升子段:

for(int i = 1;i <= n;i++) {

        if(a[i] > a[i - 1]) dp1[i] = dp1[i - 1] + 1;

        else dp1[i] = 1;

}

 for(int i = n;i >= 1;i--){

        if(a[i] < a[i + 1]) dp2[i] = dp2[i + 1] + 1;
        else dp2[i] = 1;

}

2. 如果要删除,我们就枚举要删除的数:

枚举下标i,如果删除掉 i 时,剩下的能连续(a[i-1]<a[i+1]),我们就可以将以a[i-1]为结尾最长连续上升子段和以a[i+1]为开头最长连续上升子段连接起来,长度为dp1[i-1] + dp2[i+1]。

注意事项:

1. 要求的是最长连续上升子段,而不是最长连续不下降子段(也就是1 1 1 1 这个最长子段长度为1)

2. 也可以不用删除数。(1 2 3 4 这个最长子段长度为4)

#include<bits/stdc++.h>
using namespace std;
#define int long long
#define endl '\n'
const int N = 2e5 + 10;
int a[N], dp1[N], dp2[N], ans;signed main() {ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);int n; cin >> n;for (int i = 1; i <= n; i++) cin >> a[i];for (int i = 1; i <= n; i++) {if (a[i] > a[i - 1]) dp1[i] = dp1[i - 1] + 1;else dp1[i] = 1;}for (int i = n; i >= 1; i--) {if (a[i] < a[i + 1]) dp2[i] = dp2[i + 1] + 1;else dp2[i] = 1;}for (int i = 1; i <= n; i++) {if (a[i - 1] < a[i + 1]) ans = max(ans, dp1[i - 1] + dp2[i + 1]);else ans = max({ ans,dp1[i],dp2[i] });}cout << ans << endl;return 0;
}

这篇关于Codeforces Round 605 (Div. 3) A~D的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/980683

相关文章

Codeforces Round #240 (Div. 2) E分治算法探究1

Codeforces Round #240 (Div. 2) E  http://codeforces.com/contest/415/problem/E 2^n个数,每次操作将其分成2^q份,对于每一份内部的数进行翻转(逆序),每次操作完后输出操作后新序列的逆序对数。 图一:  划分子问题。 图二: 分而治之,=>  合并 。 图三: 回溯:

Codeforces Round #261 (Div. 2)小记

A  XX注意最后输出满足条件,我也不知道为什么写的这么长。 #define X first#define Y secondvector<pair<int , int> > a ;int can(pair<int , int> c){return -1000 <= c.X && c.X <= 1000&& -1000 <= c.Y && c.Y <= 1000 ;}int m

Codeforces Beta Round #47 C凸包 (最终写法)

题意慢慢看。 typedef long long LL ;int cmp(double x){if(fabs(x) < 1e-8) return 0 ;return x > 0 ? 1 : -1 ;}struct point{double x , y ;point(){}point(double _x , double _y):x(_x) , y(_y){}point op

Codeforces Round #113 (Div. 2) B 判断多边形是否在凸包内

题目点击打开链接 凸多边形A, 多边形B, 判断B是否严格在A内。  注意AB有重点 。  将A,B上的点合在一起求凸包,如果凸包上的点是B的某个点,则B肯定不在A内。 或者说B上的某点在凸包的边上则也说明B不严格在A里面。 这个处理有个巧妙的方法,只需在求凸包的时候, <=  改成< 也就是说凸包一条边上的所有点都重复点都记录在凸包里面了。 另外不能去重点。 int

Codeforces 482B 线段树

求是否存在这样的n个数; m次操作,每次操作就是三个数 l ,r,val          a[l] & a[l+1] &......&a[r] = val 就是区间l---r上的与的值为val 。 也就是意味着区间[L , R] 每个数要执行 | val 操作  最后判断  a[l] & a[l+1] &......&a[r] 是否= val import ja

CSS实现DIV三角形

本文内容收集来自网络 #triangle-up {width: 0;height: 0;border-left: 50px solid transparent;border-right: 50px solid transparent;border-bottom: 100px solid red;} #triangle-down {width: 0;height: 0;bor

创建一个大的DIV,里面的包含两个DIV是可以自由移动

创建一个大的DIV,里面的包含两个DIV是可以自由移动 <body>         <div style="position: relative; background:#DDF8CF;line-height: 50px"> <div style="text-align: center; width: 100%;padding-top: 0px;"><h3>定&nbsp;位&nbsp;

Codeforces Round 971 (Div. 4) (A~G1)

A、B题太简单,不做解释 C 对于 x y 两个方向,每一个方向至少需要 x / k 向上取整的步数,取最大值。 由于 x 方向先移动,假如 x 方向需要的步数多于 y 方向的步数,那么最后 y 方向的那一步就不需要了,答案减 1 代码 #include <iostream>#include <algorithm>#include <vector>#include <string>

CF#271 (Div. 2) D.(dp)

D. Flowers time limit per test 1.5 seconds memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/474/problem/D We s

CF #278 (Div. 2) B.(暴力枚举+推导公式+数学构造)

B. Candy Boxes time limit per test 1 second memory limit per test 256 megabytes input standard input output standard output 题目链接: http://codeforces.com/contest/488/problem/B There